require "states/Level1/grunt"
guns = entities:new()

function guns:setplayermaxAmmo(value)
  self.maxplayerAmmo = value
end

function guns:setplayerAmmo(value)
  self.playerAmmo = value
end

function guns:setplayerClip(value)
  self.playerClip = value
end

function guns:setplayermaxClip(value)
  self.playermaxClip = value
end
function guns:setenemymaxAmmo(value)
  self.enemymaxAmmo = value
end

function guns:setenemyAmmo(value)
  self.enemyAmmo = value
end

function guns:setenemyClip(value)
  self.enemyClip = value
end

function guns:setenemymaxClip(value)
  self.enemymaxClip = value
end

function guns:setreloadDelay(value)
  self.reloadDelay = value
end

function guns:setreloadCD(value)
  self.reloadCD = value
end

function guns:getplayermaxAmmo()
  return self.playermaxAmmo
end

function guns:getplayerAmmo()
  return self.playerAmmo
end

function guns:getplayermaxClip()
  return self.playermaxClip
end

function guns:getplayerClip()
  return self.playerClip
end

function guns:getenemymaxAmmo()
  return self.enemymaxAmmo
end

function guns:getenemyAmmo()
  return self.enemyAmmo
end

function guns:getenemymaxClip()
  return self.enemymaxClip
end

function guns:getenemyClip()
  return self.enemyClip
end

function guns:getreloadDelay()
  return self.reloadDelay
end

function guns:getreloadCD()
  return self.reloadCD
end

function guns:isReload()
  return self.canReload
end

function guns:canplayerShoot()
  if self:getplayerClip()>=1 and self:getreloadDelay() == 0 and self:getfireCD() == 0 then
    return true
  else 
    return false
  end
end

function guns:canenemyShoot()
  local i,v
  for i,v in ipairs(grunt.bodies) do -- iterates for each enemy's weapon and checks these conditions to deterime whether the enemy can shoot
    if v.wep.Clip >= 1 and v.wep.rDelay == 0 and v.wep.fCD == 0 then
      v.wep.cShoot = true
    else
      v.wep.cShoot = false
    end
  end
end

function guns:getfireCD()
  return self.fireCD
end

function guns:setfireCD(value)
  self.fireCD = value
end

function guns:setfirerate(value)
  self.firerate = value
end

function guns:getfirerate()
  return self.firerate
end

function guns:fireCDupdate(dt)
  self.fireCD = math.max(0, self.fireCD - dt)
end

function guns:reloadupdate(dt)
  self.reloadDelay = math.max(0, self.reloadDelay - dt)
end

function guns:setReload(bool)
  self.canReload = bool
end

function guns:playerammo(dt) -- keeps track of the ammo in the gun
  local playermaxammo = self:getplayermaxAmmo()
  local playerammo = self:getplayerAmmo()
  local playermaxclip = self:getplayermaxClip()
  local playerclip = self:getplayerClip()
  local reloadAmount = playermaxclip - playerclip
  
  if playerclip < playermaxclip and playerammo > 0 then
    self:setReload(true) -- they player is able to reload
  end
  if playerammo <= 0 then
    self:setplayerAmmo(0)
  end
  
  if playerclip <= 0 then
    playerclip = 0
    self:setplayerClip(playerclip)
    self:playerreload(dt) -- reload if no ammo in clip
  end
  
end

function guns:enemyammo(dt)
  local i,v
  for i,v in ipairs(grunt.bodies) do
    if v.wep.Clip < v.wep.maxClip and v.wep.Ammo > 0 then
      v.wep.cReload = true
    end
    if v.wep.Ammo <= 0 then
      v.wep.Ammo = 0
    end
    
    if v.wep.Clip <= 0 then
      v.wep.Clip =0
      self:enemyreload(dt)
    end
  end
end

function guns:playerreload(dt) -- called when the corresponding keybind is pressed
  local playerammo = self:getplayerAmmo()
  local playermaxclip = self:getplayermaxClip()
  local playerclip = self:getplayerClip()
  local reloadAmount = playermaxclip - playerclip
  local reload = self:isReload()
  
  if reloadAmount > playerammo then
    reloadAmount = playerammo
  end
  
  if reload then
    self:reloadupdate(dt) -- start the reload cooldown where the player cant shoot
    self:setplayerClip(playerclip + reloadAmount)
    self:setplayerAmmo(playerammo - reloadAmount)
    self:setreloadDelay(self:getreloadCD())
  end
  self:setReload(false)
end

function guns:getOwner()
  return self.owner
end

function guns:setOwner(name)
  self.owner = name
end

function guns:enemyreload(dt)
  local i,v
  for i,v in ipairs(grunt.bodies) do
    local reloadAmount = v.wep.maxClip - v.wep.Clip
    local reload = v.wep.cReload
    
    if reloadAmount > v.wep.Ammo then
      reloadAmount = v.wep.Ammo
    end
    v.wep.rDelay = math.max(0, v.wep.rDelay - dt) -- the reload delay is equal to the higher of the 2 arguments, 0 or (v.wep.rDelay - dt)
    if reload and v.wep.Clip == 0 then
      
      v.wep.Clip = v.wep.Clip + reloadAmount
      v.wep.Ammo = v.wep.Ammo - reloadAmount
      v.wep.rDelay = v.wep.rCD -- resets the reload delay to the reload cooldown so the enemy cant shoot until it has reached 0 again
    end
    v.wep.cReload = false
  end
end

function guns:playerShoot(dt)
  self:fireCDupdate(dt)
  self:reloadupdate(dt)
  if self:canplayerShoot() then
    if love.mouse.isDown(keybind.shoot) then -- shoot if mouse button is held, the firing CD and reload CD is 0 
      return true
    end
  end
end

function guns:playerfire(dt)
  local maxplayerRifleAmmo = self:getplayermaxAmmo()
  local playerRifleAmmo = self:getplayerAmmo()
  local playerClip = self:getplayerClip()
  local playermaxClip = self:getplayermaxClip()
  
  if self:playerShoot(dt) then
    local gun = player:getGun()
    if gun == M4:getName() then
      self:setfireCD(self:getfirerate())
      M4Bullet:gen(2000, 50)
      playerClip = playerClip - 1
      self:setplayerClip(playerClip)
    end
  end
end

function guns:enemyfire(dt)
    local i,v
    for i,v in ipairs(grunt.bodies) do
      v.wep.fCD = math.max(0, v.wep.fCD - dt)
      if v.wep.cShoot and v.cSee and v.life then
        v.wep.fCD = v.wep.fRate
        eM4Bullet:gen(v.x, v.y, v.angle, 2000, 20) -- generated a bullet for each enemy x and y where they can shoot and can see the player 
        v.wep.Clip = v.wep.Clip - 1
        print(v.wep.Clip)
      end
    end
  end

function guns:playerupdate(dt)
  self:playerfire(dt)
  self:playerammo(dt)
end

function guns:enemyupdate(dt)
  self:enemyfire(dt)
  self:enemyammo(dt)
  self:canenemyShoot(dt)
  self:enemyreload(dt)
end

